import sys
import UI
import Data
import SMTbuilder
import re
import math
import subprocess
import configuration
import time

if __name__ == "__main__":
	#arguments: 1:fomulaList filename, 2: time lists filename (output format: n m time, for n # variables, m length of the formula.
    #It returns the minimum (in order to avoid spureal resuts) of solving the three formulas in the input, first only z3 time, second row also with preprocessing time
    # 3: logic
    
	 
	 SMTcode = "z3codes/smtcode"
	 z3bin = configuration.Z3_LOCATION
    
	 #preprocT = sys.argv[4] == "1"
    
	 outp = open(sys.argv[2], "w")
    
	 with open(sys.argv[1]) as FILE:
		  for line in FILE:
				parts = re.split(":",line)
				preprocT = []
				noPreprocT = []
				n = 0
				for i in parts[2:]:
					 n = n +1
					 preprocI = time.time()
					 rData = Data.RawData(sys.argv[3], "th",[i])
					 smtStructure = SMTbuilder.SMT(rData, SMTcode)
					 noPreprocI = time.time()
					 outputz3 = subprocess.call([z3bin, "-smt2", SMTcode])
					 ftime = time.time()
					 
					 rtime = ftime - preprocI
					 nptime = ftime - noPreprocI
					 
					 preprocT.append(rtime)
					 noPreprocT.append(nptime)
				outp.write(parts[0] + " " + parts[1] + " " + str(min(noPreprocT)) + " " + str(min(preprocT)) + "\n")
