#!/bin/sh

#  testsScript.sh
#  
#
#  Created by amanda on 20/4/15.
#

vstep=20
nvsteps=80
lstep=20
nlsteps=130

python ./tests/genFormulas.py $vstep $nvsteps $lstep $nlsteps 0 0 3 "./tests/formulasFiles/formulas00"
python ./tests/genFormulas.py $vstep $nvsteps $lstep $nlsteps 0 1 3 "./tests/formulasFiles/formulas01"
python ./tests/genFormulas.py $vstep $nvsteps $lstep $nlsteps 1 0 3 "./tests/formulasFiles/formulas10"
python ./tests/genFormulas.py $vstep $nvsteps $lstep $nlsteps 1 1 3 "./tests/formulasFiles/formulas11"

echo "lukasiewicz cases"
echo "00N"
#timeout 3h
python exeTest.py "./tests/formulasFiles/formulas00" "./tests/timesFiles/formulas00LN" "(0,1)l"
wait
echo "01N"
#timeout 3h
python exeTest.py "./tests/formulasFiles/formulas01" "./tests/timesFiles/formulas01LN" "(0,1)l"
wait
echo "10N"
timeout 3h python exeTest.py "./tests/formulasFiles/formulas10" "./tests/timesFiles/formulas10LN" "(0,1)l"
wait
echo "11N"
timeout 3h python exeTest.py "./tests/formulasFiles/formulas11" "./tests/timesFiles/formulas11LN" "(0,1)l"
wait
echo "product cases"
echo "00N"
timeout 3h python exeTest.py "./tests/formulasFiles/formulas00" "./tests/timesFiles/formulas00PN" "(0,1)p"
wait
echo "01N"
timeout 3h python exeTest.py "./tests/formulasFiles/formulas01" "./tests/timesFiles/formulas01PN" "(0,1)p"
wait
echo "10N"
timeout 3h python exeTest.py "./tests/formulasFiles/formulas10" "./tests/timesFiles/formulas10PN" "(0,1)p"
wait
echo "11N"
timeout 3h python exeTest.py "./tests/formulasFiles/formulas11" "./tests/timesFiles/formulas11PN" "(0,1)p"
wait
echo "godel cases"
echo "00N"
timeout 3h python exeTest.py "./tests/formulasFiles/formulas00" "./tests/timesFiles/formulas00GN" "(0,1)g"
wait
echo "01N"
timeout 3h python exeTest.py "./tests/formulasFiles/formulas01" "./tests/timesFiles/formulas01GN" "(0,1)g"
wait
echo "10N"
timeout 3h python exeTest.py "./tests/formulasFiles/formulas10" "./tests/timesFiles/formulas10GN" "(0,1)g"
wait
echo "11N"
timeout 3h python exeTest.py "./tests/formulasFiles/formulas11" "./tests/timesFiles/formulas11GN" "(0,1)g"
wait
echo "BL cases"
echo "00N"
timeout 3h python exeTest.py "./tests/formulasFiles/formulas00" "./tests/timesFiles/formulas00BLN" "bl"
wait
echo "01N"
timeout 3h python exeTest.py "./tests/formulasFiles/formulas01" "./tests/timesFiles/formulas01BLN" "bl"
wait
